import Stomp from 'stompjs'

export default class MessageBridge {
  websokcetCalc;
  websocketAdapter;
  constructor() {
    this.websokcetCalc = new WebSocket(onmessage, "ws://192.168.10.18:8011/wisdom", ["/topic/suggestion", "/topic/sync-command-result", "/topic/fault-count",
      "/topic/alarm-count", "/topic/fault-popup", "/topic/popup-remove", "/topic/heartbeat-data"]);
    //this.websocketAdapter=new WebSocket(onmessage,"")
  }
  onmessage(msg) {
    console.log(msg);
  }
}

class WebSocket {
  onmessage;
  url;
  settings;
  client;
  constructor(onmessage, url, settings) {
    this.onmessage = onmessage;
    this.url = url;
    this.settings = settings;
    try {
      this.connect();
    } catch (e) {
      console.log("websocket连接错误:" + e);
    }

    console.log("websocket");
  }

  connect() {
    if (this.client != null) {
      this.client.close();
    }
    this.client = Stomp.client(this.url);
    this.client.connect({}, this.connectCallBackSubscribe, this.reconnect);
  }

  /* 注册 */
  connectCallBackSubscribe() {
    if (this.settings == null || this.settings.length <= 0) return;
    for (var st in this.settings) {
      this.client.subscribe(st, frame => this.onmessage(frame));// 启停推荐
    }
  }

  /* 发送 */
  send(destination, headers, body) {
    if (this.calcClient && this.calcClient.connected) {
      this.calcClient.send(destination, headers, body);
    }
  }

  /* 重新连接 */
  reconnect() {
    this.calcClient.connected = false;
    clearTimeout(setTimeout(this.connect(), 5000));
  }
}